// (C) DownThemAll! - See COPYING/SOURCE

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;
const log = Components.utils.reportError;

const CHROME_URI = 'chrome://dtaac/content/webinstall.xhtml';

const MAX_SIZE = 1048576;
const SEG_SIZE = 16384;
Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
const StorageStream = Components.Constructor('@mozilla.org/storagestream;1', 'nsIStorageStream', 'init');
const BufferedOutputStream = Components.Constructor('@mozilla.org/network/buffered-output-stream;1', 'nsIBufferedOutputStream', 'init');
function WebInstallConverter() {};
WebInstallConverter.prototype = {
classDescription: "DownThemAll! AutoContainer webinstall stream converter",
classID: Components.ID('3d349f10-2a07-11de-8c30-0800200c9a66'),
contractID: '@mozilla.org/streamconv;1?from=application/x-anticontainer-plugin&to=*/*',
QueryInterface: XPCOMUtils.generateQI([Ci.nsIStreamConverter, Ci.nsIStreamListener, Ci.nsIRequestObserver]),

onStartRequest: function(request, context) {
try {

let chan = request.QueryInterface(Ci.nsIChannel);

this._storage = new StorageStream(SEG_SIZE, MAX_SIZE, null);
this._out = this._storage.getOutputStream(0);
this._bout = new BufferedOutputStream(this._out, SEG_SIZE);
}
catch (ex) {
log(ex);
throw ex;
}
},
onStopRequest: function(request, context, status) {
try {
let plugs = {};
Components.utils.import('resource://dtaac/plugins.jsm', plugs);

this._bout.flush();
this._out.close();

let input = this._storage.newInputStream(0);
let chan = request.QueryInterface(Ci.nsIChannel);
try {
let p = plugs.loadPluginFromStream(input);
plugs.pushPlugin(chan.URI.spec, p);
}
catch (ex) {
log(ex);
plugs.pushPlugin(chan.URI.spec, ex.toString());
}
input.close();

let io = Cc['@mozilla.org/network/io-service;1'].getService(Ci.nsIIOService);
let chrome = io.newChannel(CHROME_URI, null, null);
chrome.originalURI = chan.URI;
chrome.loadGroup = request.loadGroup;
chrome.asyncOpen(this._listener, null);
}
catch (ex) {
log(ex);
throw ex;
}
},

onDataAvailable: function(request, context, input, offset, count) {
try {
this._bout.writeFrom(input, count);
}
catch (ex) {
log(ex);
throw ex;
}
},

convert: function() Cr.NS_ERROR_NOT_IMPLEMENTED,
asyncConvertData: function(from, to, listener, context) {

this._listener = listener;
}
};
function NSGetModule(compMgr, fileSpec) {
return XPCOMUtils.generateModule([WebInstallConverter]);
}